
#include "WidgetMessageFilter.h"
#include <cassert>
#include <Windows.h>

#ifdef _DEBUG
#include <sstream>
#include <iomanip>
#endif // _DEBUG

namespace ghost{

	namespace widget{

		LRESULT MessageFilter::Filter(const Param& param)
		{
			assert(param.originalProc);
#ifdef _DEBUG
			std::stringstream ss;
			ss<<"Ϣ: "<<std::showbase<<std::hex<<param.message<<" WidgetϢˣ\r\n";
			::OutputDebugStringA(ss.str().c_str());
#endif // _DEBUG
			return ::CallWindowProc(
				param.originalProc, 
				param.hWnd, 
				param.message, 
				param.wParam, 
				param.lParam);
		}

	} // namespace widget

} // namespace ghost